# Table of Contents
- [Table of Contents](#table-of-contents)
- [Demos and supported functionality](#demos-and-supported-functionality)
  * [PHP](#php)
  * [JavaScript](#javascript)
  * [Python](#python)
  * [Scala](#scala)

# Demos and supported functionality

This README contains several demos of some of the languages being supported by
DoGe and also specifies _what_ is being supported.

## PHP

Supported:
- Class properties (based on the constructor of the surrounding class)
- Class methods
- Functions

[Demo](https://vdoge.kimkoomen.nl/demos/doge-demo-php.gif)

## JavaScript

JavaScript is one of the most complicated ones to support, because of all the
EcmaScript features and libraries that add TypeScript-like type hints.
Nonetheless, DoGe supports all of it.

Supported:
- Regular functions
- Prototype functions
- ES6
  - Fat-arrow functions
  - Classes
  - Class methods
  - Destructuring in parameter lists
- FlowJS/TypeScript-like type hints

All of the above is _also_ supported for TypeScript and NodeJS.

[Demo](https://vdoge.kimkoomen.nl/demos/doge-demo-javascript.gif)

## Python

Supported:
- Functions
- Class methods.
- Doc standards
  - reST
  - Numpy
  - Google
- Python 3.7+ type hints

[Demo](https://vdoge.kimkoomen.nl/demos/doge-demo-python.gif)

## Scala

Supported:
- Functions
- Methods
- Classes

[Demo](https://vdoge.kimkoomen.nl/demos/doge-demo-scala.gif)
